/*
 *  Copyright (c) 2023 Fraunhofer Institute for Applied Information Technology
 *
 *  This program and the accompanying materials are made available under the
 *  terms of the Apache License, Version 2.0 which is available at
 *  https://www.apache.org/licenses/LICENSE-2.0
 *
 *  SPDX-License-Identifier: Apache-2.0
 *
 */

package org.fraunhofer.fit.extension.extractor;

import org.eclipse.edc.runtime.metamodel.annotation.Extension;
import org.eclipse.edc.runtime.metamodel.annotation.Inject;
import org.eclipse.edc.runtime.metamodel.annotation.Provider;
import org.eclipse.edc.spi.monitor.Monitor;
import org.eclipse.edc.spi.system.ServiceExtension;
import org.eclipse.edc.spi.system.ServiceExtensionContext;
import org.eclipse.edc.web.spi.WebService;


@Extension(value = MetadataExtractorExtension.NAME)
public class MetadataExtractorExtension implements ServiceExtension {

    public static final String NAME = "Metadata Extractor";
    private Monitor monitor;
    @Inject
    WebService webService;

    @Override
    public void initialize(ServiceExtensionContext context) {
        this.monitor = context.getMonitor();
        webService.registerResource(new ExtractorApiController(monitor));
    }

    @Provider(isDefault = true)
    public MetadataExtractor fairEvaluator() {
        return new MetadataExtractor(monitor);
    }
}